# Class VulkanDebugUtilsMessengerCreateInfoEXT

java.lang.Object
com.io7m.jcoronado.extensions.ext_debug_utils.api.VulkanDebugUtilsMessengerCreateInfoEXT

All Implemented Interfaces:
  `VulkanDebugUtilsMessengerCreateInfoEXTType`

public final class VulkanDebugUtilsMessengerCreateInfoEXT extends Object implements VulkanDebugUtilsMessengerCreateInfoEXTType
Structure specifying parameters of a newly created debug messenger.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanDebugUtilsMessengerCreateInfoEXT.Builder`
  Builds instances of type `VulkanDebugUtilsMessengerCreateInfoEXT`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanDebugUtilsMessengerCreateInfoEXT.Builder`
  `builder()`
  Creates a builder for `VulkanDebugUtilsMessengerCreateInfoEXT`.
  `VulkanDebugUtilsMessengerCallbackEXTType`
  `callback()`
  `static VulkanDebugUtilsMessengerCreateInfoEXT`
  `copyOf(VulkanDebugUtilsMessengerCreateInfoEXTType instance)`
  Creates an immutable copy of a `VulkanDebugUtilsMessengerCreateInfoEXTType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanDebugUtilsMessengerCreateInfoEXT` that have equal attribute values.
  `Set<VulkanDebugUtilsMessengerCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `severity`, `type`, `callback`.
  `Set<VulkanDebugUtilsMessageSeverityFlag>`
  `severity()`
  `String`
  `toString()`
  Prints the immutable value `VulkanDebugUtilsMessengerCreateInfoEXT` with attribute values.
  `Set<VulkanDebugUtilsMessageTypeFlag>`
  `type()`
  `final VulkanDebugUtilsMessengerCreateInfoEXT`
  `withCallback(VulkanDebugUtilsMessengerCallbackEXTType value)`
  Copy the current immutable object by setting a value for the `callback` attribute.
  `final VulkanDebugUtilsMessengerCreateInfoEXT`
  `withFlags(VulkanDebugUtilsMessengerCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanDebugUtilsMessengerCreateInfoEXT`
  `withFlags(Iterable<VulkanDebugUtilsMessengerCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanDebugUtilsMessengerCreateInfoEXT`
  `withSeverity(VulkanDebugUtilsMessageSeverityFlag... elements)`
  Copy the current immutable object with elements that replace the content of `severity`.
  `final VulkanDebugUtilsMessengerCreateInfoEXT`
  `withSeverity(Iterable<VulkanDebugUtilsMessageSeverityFlag> elements)`
  Copy the current immutable object with elements that replace the content of `severity`.
  `final VulkanDebugUtilsMessengerCreateInfoEXT`
  `withType(VulkanDebugUtilsMessageTypeFlag... elements)`
  Copy the current immutable object with elements that replace the content of `type`.
  `final VulkanDebugUtilsMessengerCreateInfoEXT`
  `withType(Iterable<VulkanDebugUtilsMessageTypeFlag> elements)`
  Copy the current immutable object with elements that replace the content of `type`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanDebugUtilsMessengerCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanDebugUtilsMessengerCreateInfoEXTType`
    Returns:
      The creation flags

  - ### severity

    public Set<VulkanDebugUtilsMessageSeverityFlag> severity()
    Specified by:
      `severity` in interface `VulkanDebugUtilsMessengerCreateInfoEXTType`
    Returns:
      The message severity selection

  - ### type

    public Set<VulkanDebugUtilsMessageTypeFlag> type()
    Specified by:
      `type` in interface `VulkanDebugUtilsMessengerCreateInfoEXTType`
    Returns:
      The message type selection

  - ### callback

    public VulkanDebugUtilsMessengerCallbackEXTType callback()
    Specified by:
      `callback` in interface `VulkanDebugUtilsMessengerCreateInfoEXTType`
    Returns:
      The message callback

  - ### withFlags

    public final VulkanDebugUtilsMessengerCreateInfoEXT withFlags(VulkanDebugUtilsMessengerCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanDebugUtilsMessengerCreateInfoEXT withFlags(Iterable<VulkanDebugUtilsMessengerCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withSeverity

    public final VulkanDebugUtilsMessengerCreateInfoEXT withSeverity(VulkanDebugUtilsMessageSeverityFlag... elements)
    Copy the current immutable object with elements that replace the content of `severity`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withSeverity

    public final VulkanDebugUtilsMessengerCreateInfoEXT withSeverity(Iterable<VulkanDebugUtilsMessageSeverityFlag> elements)
    Copy the current immutable object with elements that replace the content of `severity`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of severity elements to set
    Returns:
      A modified copy of `this` object

  - ### withType

    public final VulkanDebugUtilsMessengerCreateInfoEXT withType(VulkanDebugUtilsMessageTypeFlag... elements)
    Copy the current immutable object with elements that replace the content of `type`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withType

    public final VulkanDebugUtilsMessengerCreateInfoEXT withType(Iterable<VulkanDebugUtilsMessageTypeFlag> elements)
    Copy the current immutable object with elements that replace the content of `type`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of type elements to set
    Returns:
      A modified copy of `this` object

  - ### withCallback

    public final VulkanDebugUtilsMessengerCreateInfoEXT withCallback(VulkanDebugUtilsMessengerCallbackEXTType value)
    Copy the current immutable object by setting a value for the `callback` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for callback
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanDebugUtilsMessengerCreateInfoEXT` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `severity`, `type`, `callback`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanDebugUtilsMessengerCreateInfoEXT` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanDebugUtilsMessengerCreateInfoEXT copyOf(VulkanDebugUtilsMessengerCreateInfoEXTType instance)
    Creates an immutable copy of a `VulkanDebugUtilsMessengerCreateInfoEXTType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanDebugUtilsMessengerCreateInfoEXT instance

  - ### builder

    public static VulkanDebugUtilsMessengerCreateInfoEXT.Builder builder()
    Creates a builder for `VulkanDebugUtilsMessengerCreateInfoEXT`.

         VulkanDebugUtilsMessengerCreateInfoEXT.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.extensions.ext_debug_utils.api.VulkanDebugUtilsMessengerCreateFlag) // flags elements
            .addSeverity|addAllSeverity(com.io7m.jcoronado.extensions.ext_debug_utils.api.VulkanDebugUtilsMessageSeverityFlag) // severity elements
            .addType|addAllType(com.io7m.jcoronado.extensions.ext_debug_utils.api.VulkanDebugUtilsMessageTypeFlag) // type elements
            .setCallback(com.io7m.jcoronado.extensions.ext_debug_utils.api.VulkanDebugUtilsMessengerCallbackEXTType) // required callback
            .build();

    Returns:
      A new VulkanDebugUtilsMessengerCreateInfoEXT builder